Index: src/hg/lib/customFactory.c
===================================================================
RCS file: /projects/compbio/cvsroot/kent/src/hg/lib/customFactory.c,v
retrieving revision 1.119
retrieving revision 1.120
diff -b -B -U 4 -r1.119 -r1.120
--- src/hg/lib/customFactory.c	9 Apr 2010 20:06:18 -0000	1.119
+++ src/hg/lib/customFactory.c	10 Apr 2010 01:13:58 -0000	1.120
@@ -1633,19 +1633,25 @@
     item->name = cloneString(row[3]);
 else
     item->name = cloneString(".");
 if (rowSize > 4) 
-    item->strand[0] = row[4][0];
+    item->score = sqlSigned(row[4]);
+if (rowSize > 5) 
+    item->strand[0] = row[5][0];
 else
     item->strand[0] = '.';
-if (rowSize > 5) 
-    item->score = sqlSigned(row[5]);
 if (rowSize > 6)
-    item->color = cloneString(row[6]);
+    item->thickStart = sqlUnsigned(row[6]);
 else
-    item->color = cloneString("0,0,0");
+    item->thickStart = item->chromStart;
 if (rowSize > 7)
-    item->description = cloneString(row[7]);
+    item->thickEnd = sqlUnsigned(row[7]);
+else
+    item->thickEnd = item->chromEnd;
+if (rowSize > 8)
+    item->itemRgb = bedParseRgb(row[8]);
+if (rowSize > 9)
+    item->description = cloneString(row[9]);
 else
     item->description = cloneString("");
 return item;
 }
@@ -1709,11 +1715,13 @@
 "    chrom varchar(255) not null,	# Reference sequence chromosome or scaffold\n"
 "    chromStart int unsigned not null,	# Start position in chromosome\n"
 "    chromEnd int unsigned not null,	# End position in chromosome\n"
 "    name varchar(255) not null,	# Name of item - up to 16 chars\n"
-"    strand char(1) not null,	# + or - for strand\n"
 "    score int unsigned not null,	# 0-1000.  Higher numbers are darker.\n"
-"    color varchar(255) not null,	# Comma separated list of RGB components.  IE 255,0,0 for red\n"
+"    strand char(1) not null,	# + or - for strand\n"
+"    thickStart int unsigned not null,	# Start of thick part\n"
+"    thickEnd int unsigned not null,	# End position of thick part\n"
+"    itemRgb int unsigned not null,	# RGB 8 bits each as in bed\n"
 "    description longblob not null,	# Longer item description\n"
 "              #Indices\n"
 "    INDEX(chrom(16),bin)\n"
 ")";