Index: src/hg/lib/customFactory.c
===================================================================
RCS file: /projects/compbio/cvsroot/kent/src/hg/lib/customFactory.c,v
retrieving revision 1.120
retrieving revision 1.121
diff -b -B -U 4 -r1.120 -r1.121
--- src/hg/lib/customFactory.c	10 Apr 2010 01:13:58 -0000	1.120
+++ src/hg/lib/customFactory.c	10 Apr 2010 06:11:50 -0000	1.121
@@ -1721,9 +1721,11 @@
 "    thickStart int unsigned not null,	# Start of thick part\n"
 "    thickEnd int unsigned not null,	# End position of thick part\n"
 "    itemRgb int unsigned not null,	# RGB 8 bits each as in bed\n"
 "    description longblob not null,	# Longer item description\n"
+"    id int auto_increment,\n"
 "              #Indices\n"
+"    PRIMARY KEY(id),\n"
 "    INDEX(chrom(16),bin)\n"
 ")";
 struct dyString *createSql = dyStringNew(0);
 dyStringPrintf(createSql, tableFormat, tableName);