Index: src/hg/lib/customFactory.c
===================================================================
RCS file: /projects/compbio/cvsroot/kent/src/hg/lib/customFactory.c,v
retrieving revision 1.121
retrieving revision 1.122
diff -b -B -U 4 -r1.121 -r1.122
--- src/hg/lib/customFactory.c	10 Apr 2010 06:11:50 -0000	1.121
+++ src/hg/lib/customFactory.c	10 Apr 2010 19:01:04 -0000	1.122
@@ -1631,9 +1631,9 @@
 item->bin = binFromRange(item->chromStart, item->chromEnd);
 if (rowSize > 3) 
     item->name = cloneString(row[3]);
 else
-    item->name = cloneString(".");
+    item->name = cloneString("");
 if (rowSize > 4) 
     item->score = sqlSigned(row[4]);
 if (rowSize > 5) 
     item->strand[0] = row[5][0];