Index: src/hg/lib/hui.c
===================================================================
RCS file: /projects/compbio/cvsroot/kent/src/hg/lib/hui.c,v
retrieving revision 1.273
retrieving revision 1.274
diff -b -B -U 4 -r1.273 -r1.274
--- src/hg/lib/hui.c	12 Apr 2010 16:12:26 -0000	1.273
+++ src/hg/lib/hui.c	12 Apr 2010 17:46:48 -0000	1.274
@@ -3196,9 +3196,9 @@
 {
 if(subgroupFind(subtrack,"view",NULL) == FALSE)
     return FALSE; // No view
 
-if(subtrack->parent == NULL || subtrack->parent->parent != NULL)
+if(subtrack->parent == NULL || subtrack->parent->parent == NULL)
     return FALSE; // Not the subtrack
 
 char * view = trackDbLocalSetting(subtrack->parent, "view");
 if(view == NULL) // assertably not null!
@@ -3211,9 +3211,9 @@
 
 safef(objName, sizeof(objName), "%s.%s.vis", subtrack->parent->parent->tableName,view);
 
 setting = cartUsualString(cart, objName, setting); // Not ClosestToHome
-return sameString(setting,TV_HIDE);
+return sameWord(setting,TV_HIDE);
 }
 
 char *tdbResolveVis(struct cart *cart,struct trackDb *tdb, boolean applyMax)
 // Determines the correct vis for a tdb as modified by parent