Index: src/hg/lib/makeItemsItem.as
===================================================================
RCS file: src/hg/lib/makeItemsItem.as
diff -N src/hg/lib/makeItemsItem.as
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ src/hg/lib/makeItemsItem.as	9 Apr 2010 17:44:19 -0000	1.1
@@ -0,0 +1,13 @@
+table makeItems
+"Browser extensible data"
+    (
+    uint bin;	       "Bin for range index"
+    string chrom;      "Reference sequence chromosome or scaffold"
+    uint   chromStart; "Start position in chromosome"
+    uint   chromEnd;   "End position in chromosome"
+    string name;       "Name of item - up to 16 chars"
+    char[1] strand;     "+ or - for strand"
+    uint  score;	"0-1000.  Higher numbers are darker."
+    string color;	"Comma separated list of RGB components.  IE 255,0,0 for red"
+    lstring description; "Longer item description"
+    )