Index: src/hg/lib/makeItemsItem.c
===================================================================
RCS file: /projects/compbio/cvsroot/kent/src/hg/lib/makeItemsItem.c,v
retrieving revision 1.4
retrieving revision 1.5
diff -b -B -U 4 -r1.4 -r1.5
--- src/hg/lib/makeItemsItem.c	10 Apr 2010 06:11:50 -0000	1.4
+++ src/hg/lib/makeItemsItem.c	10 Apr 2010 18:39:02 -0000	1.5
@@ -25,8 +25,9 @@
 ret->thickStart = sqlUnsigned(row[7]);
 ret->thickEnd = sqlUnsigned(row[8]);
 ret->itemRgb = sqlUnsigned(row[9]);
 ret->description = row[10];
+ret->id = sqlUnsigned(row[11]);
 }
 
 struct makeItemsItem *makeItemsItemLoadByQuery(struct sqlConnection *conn, char *query)
 /* Load all makeItemsItem from table that satisfy the query given.  
@@ -59,10 +60,10 @@
  * For example "autosql's features include" --> "autosql\'s features include" 
  * If worried about this use makeItemsItemSaveToDbEscaped() */
 {
 struct dyString *update = newDyString(updateSize);
-dyStringPrintf(update, "insert into %s values ( %u,'%s',%u,%u,'%s',%u,'%s',%u,%u,%u,%s,0)", 
-	tableName,  el->bin,  el->chrom,  el->chromStart,  el->chromEnd,  el->name,  el->score,  el->strand,  el->thickStart,  el->thickEnd,  el->itemRgb,  el->description);
+dyStringPrintf(update, "insert into %s values ( %u,'%s',%u,%u,'%s',%u,'%s',%u,%u,%u,%s,%u)", 
+	tableName,  el->bin,  el->chrom,  el->chromStart,  el->chromEnd,  el->name,  el->score,  el->strand,  el->thickStart,  el->thickEnd,  el->itemRgb,  el->description,  el->id);
 sqlUpdate(conn, update->string);
 freeDyString(&update);
 }
 
@@ -81,10 +82,10 @@
 name = sqlEscapeString(el->name);
 strand = sqlEscapeString(el->strand);
 description = sqlEscapeString(el->description);
 
-dyStringPrintf(update, "insert into %s values ( %u,'%s',%u,%u,'%s',%u,'%s',%u,%u,%u,'%s',0)", 
-	tableName,  el->bin,  chrom,  el->chromStart,  el->chromEnd,  name,  el->score,  strand,  el->thickStart,  el->thickEnd,  el->itemRgb,  description);
+dyStringPrintf(update, "insert into %s values ( %u,'%s',%u,%u,'%s',%u,'%s',%u,%u,%u,'%s',%u)", 
+	tableName,  el->bin,  chrom,  el->chromStart,  el->chromEnd,  name,  el->score,  strand,  el->thickStart,  el->thickEnd,  el->itemRgb,  description,  el->id);
 sqlUpdate(conn, update->string);
 freeDyString(&update);
 freez(&chrom);
 freez(&name);
@@ -109,8 +110,9 @@
 ret->thickStart = sqlUnsigned(row[7]);
 ret->thickEnd = sqlUnsigned(row[8]);
 ret->itemRgb = sqlUnsigned(row[9]);
 ret->description = cloneString(row[10]);
+ret->id = sqlUnsigned(row[11]);
 return ret;
 }
 
 struct makeItemsItem *makeItemsItemLoadAll(char *fileName) 
@@ -118,9 +120,9 @@
  * Dispose of this with makeItemsItemFreeList(). */
 {
 struct makeItemsItem *list = NULL, *el;
 struct lineFile *lf = lineFileOpen(fileName, TRUE);
-char *row[11];
+char *row[12];
 
 while (lineFileRow(lf, row))
     {
     el = makeItemsItemLoad(row);
@@ -136,9 +138,9 @@
  * Dispose of this with makeItemsItemFreeList(). */
 {
 struct makeItemsItem *list = NULL, *el;
 struct lineFile *lf = lineFileOpen(fileName, TRUE);
-char *row[11];
+char *row[12];
 
 while (lineFileNextCharRow(lf, chopper, row, ArraySize(row)))
     {
     el = makeItemsItemLoad(row);
@@ -168,8 +170,9 @@
 ret->thickStart = sqlUnsignedComma(&s);
 ret->thickEnd = sqlUnsignedComma(&s);
 ret->itemRgb = sqlUnsignedComma(&s);
 ret->description = sqlStringComma(&s);
+ret->id = sqlUnsignedComma(&s);
 *pS = s;
 return ret;
 }
 
@@ -230,8 +233,10 @@
 fputc(sep,f);
 if (sep == ',') fputc('"',f);
 fprintf(f, "%s", el->description);
 if (sep == ',') fputc('"',f);
+fputc(sep,f);
+fprintf(f, "%u", el->id);
 fputc(lastSep,f);
 }
 
 /* -------------------------------- End autoSql Generated Code -------------------------------- */