Index: src/hg/lib/makeItemsItem.sql
===================================================================
RCS file: src/hg/lib/makeItemsItem.sql
diff -N src/hg/lib/makeItemsItem.sql
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ src/hg/lib/makeItemsItem.sql	9 Apr 2010 17:44:20 -0000	1.1
@@ -0,0 +1,19 @@
+# makeItemsItem.sql was originally generated by the autoSql program, which also 
+# generated makeItemsItem.c and makeItemsItem.h.  This creates the database representation of
+# an object which can be loaded and saved from RAM in a fairly 
+# automatic way.
+
+#Browser extensible data
+CREATE TABLE makeItems (
+    bin int unsigned not null,	# Bin for range index
+    chrom varchar(255) not null,	# Reference sequence chromosome or scaffold
+    chromStart int unsigned not null,	# Start position in chromosome
+    chromEnd int unsigned not null,	# End position in chromosome
+    name varchar(255) not null,	# Name of item - up to 16 chars
+    strand char(1) not null,	# + or - for strand
+    score int unsigned not null,	# 0-1000.  Higher numbers are darker.
+    color varchar(255) not null,	# Comma separated list of RGB components.  IE 255,0,0 for red
+    description longblob not null,	# Longer item description
+              #Indices
+    INDEX(chrom(16),bin)
+);