Index: src/hg/lib/makeItemsItem.sql
===================================================================
RCS file: /projects/compbio/cvsroot/kent/src/hg/lib/makeItemsItem.sql,v
retrieving revision 1.1
retrieving revision 1.2
diff -b -B -U 4 -r1.1 -r1.2
--- src/hg/lib/makeItemsItem.sql	9 Apr 2010 17:44:20 -0000	1.1
+++ src/hg/lib/makeItemsItem.sql	9 Apr 2010 17:45:57 -0000	1.2
@@ -2,10 +2,10 @@
 # generated makeItemsItem.c and makeItemsItem.h.  This creates the database representation of
 # an object which can be loaded and saved from RAM in a fairly 
 # automatic way.
 
-#Browser extensible data
-CREATE TABLE makeItems (
+#An item in a makeItems type track.
+CREATE TABLE makeItemsItem (
     bin int unsigned not null,	# Bin for range index
     chrom varchar(255) not null,	# Reference sequence chromosome or scaffold
     chromStart int unsigned not null,	# Start position in chromosome
     chromEnd int unsigned not null,	# End position in chromosome