Index: src/hg/lib/makeItemsItem.sql
===================================================================
RCS file: /projects/compbio/cvsroot/kent/src/hg/lib/makeItemsItem.sql,v
retrieving revision 1.3
retrieving revision 1.4
diff -b -B -U 4 -r1.3 -r1.4
--- src/hg/lib/makeItemsItem.sql	10 Apr 2010 01:13:58 -0000	1.3
+++ src/hg/lib/makeItemsItem.sql	10 Apr 2010 06:11:51 -0000	1.4
@@ -15,7 +15,9 @@
     thickStart int unsigned not null,	# Start of thick part
     thickEnd int unsigned not null,	# End position of thick part
     itemRgb int unsigned not null,	# RGB 8 bits each as in bed
     description longblob not null,	# Longer item description
+    id int auto_increment,
               #Indices
+    PRIMARY KEY(id),
     INDEX(chrom(16),bin)
 );