Index: src/hg/lib/trackDb.c
===================================================================
RCS file: /projects/compbio/cvsroot/kent/src/hg/lib/trackDb.c,v
retrieving revision 1.9
retrieving revision 1.10
diff -b -B -U 4 -r1.9 -r1.10
--- src/hg/lib/trackDb.c	23 Jan 2009 22:19:47 -0000	1.9
+++ src/hg/lib/trackDb.c	12 Apr 2010 16:17:22 -0000	1.10
@@ -168,8 +168,9 @@
 freeMem(el->grp);
 freeMem(el->settings);
 hashFree(&el->settingsHash);
 hashFree(&el->overrides);
+hashFree(&el->extras);
 freez(pEl);
 }
 
 void trackDbFreeList(struct trackDb **pList)